package org.apache.bcel.util;

import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantClass;
import java.io.IOException;
import java.io.InputStream;
import org.apache.bcel.classfile.ClassParser;
import java.io.ByteArrayInputStream;
import org.apache.bcel.classfile.Utility;
import org.apache.bcel.classfile.JavaClass;
import java.util.Hashtable;

@Deprecated
public class ClassLoader extends java.lang.ClassLoader
{
    private static final String BCEL_TOKEN = "$$BCEL$$";
    public static final String[] DEFAULT_IGNORED_PACKAGES;
    private final Hashtable<String, Class<?>> classes;
    private final String[] ignoredPackages;
    private Repository repository;
    
    public ClassLoader() {
        this(ClassLoader.DEFAULT_IGNORED_PACKAGES);
    }
    
    public ClassLoader(final java.lang.ClassLoader deferTo) {
        super(deferTo);
        this.classes = new Hashtable<String, Class<?>>();
        this.repository = SyntheticRepository.getInstance();
        this.ignoredPackages = ClassLoader.DEFAULT_IGNORED_PACKAGES;
        this.repository = new ClassLoaderRepository(deferTo);
    }
    
    public ClassLoader(final java.lang.ClassLoader deferTo, final String[] ignoredPackages) {
        this(ignoredPackages);
        this.repository = new ClassLoaderRepository(deferTo);
    }
    
    public ClassLoader(final String[] ignoredPackages) {
        this.classes = new Hashtable<String, Class<?>>();
        this.repository = SyntheticRepository.getInstance();
        this.ignoredPackages = ignoredPackages;
    }
    
    protected JavaClass createClass(final String className) {
        final int index = className.indexOf("$$BCEL$$");
        final String realName = className.substring(index + "$$BCEL$$".length());
        JavaClass clazz = null;
        try {
            final byte[] bytes = Utility.decode(realName, true);
            final ClassParser parser = new ClassParser(new ByteArrayInputStream(bytes), "foo");
            clazz = parser.parse();
        }
        catch (final IOException e) {
            e.printStackTrace();
            return null;
        }
        final ConstantPool cp = clazz.getConstantPool();
        final ConstantClass cl = (ConstantClass)cp.getConstant(clazz.getClassNameIndex(), (byte)7, (Class)ConstantClass.class);
        final ConstantUtf8 name = cp.getConstantUtf8(cl.getNameIndex());
        name.setBytes(className.replace('.', '/'));
        return clazz;
    }
    
    @Override
    protected Class<?> loadClass(final String className, final boolean resolve) throws ClassNotFoundException {
        Class<?> cl = null;
        if ((cl = this.classes.get(className)) == null) {
            for (final String ignoredPackage : this.ignoredPackages) {
                if (className.startsWith(ignoredPackage)) {
                    cl = this.getParent().loadClass(className);
                    break;
                }
            }
            if (cl == null) {
                JavaClass clazz = null;
                if (className.contains("$$BCEL$$")) {
                    clazz = this.createClass(className);
                }
                else {
                    if ((clazz = this.repository.loadClass(className)) == null) {
                        throw new ClassNotFoundException(className);
                    }
                    clazz = this.modifyClass(clazz);
                }
                if (clazz != null) {
                    final byte[] bytes = clazz.getBytes();
                    cl = this.defineClass(className, bytes, 0, bytes.length);
                }
                else {
                    cl = Class.forName(className);
                }
            }
            if (resolve) {
                this.resolveClass(cl);
            }
        }
        this.classes.put(className, cl);
        return cl;
    }
    
    protected JavaClass modifyClass(final JavaClass clazz) {
        return clazz;
    }
    
    static {
        DEFAULT_IGNORED_PACKAGES = new String[] { "java.", "javax.", "sun." };
    }
}
